package com.example.tracktrek;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.StreamCorruptedException;
import java.util.ArrayList;
import java.util.List;

import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.Point;
import android.os.Bundle;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;


/**
 * MapTrial is the fruit of our Google researching. It creates all the colors used
 * on the route, and creates many path segments to be drawn onto the google map.
 *
 */
public class MapTrial extends MapActivity {
	/** Called when the activity is first created. */
	private List mapOverlays;
	private Projection projection;
	private MapController mc;
	private MapView mapView;
	private GeoPoint gP;
	private MyOverlay myoverlay;

	double lati;
	double longi;
	double latA[];
	double longA[];
	double Alt;
	double AltA[];
	double AltA1[] = new double[2];
	private int length;
	private int Alength;
	
	int RColor;
	int GColor;
	int BColor;
	int Alpha;
	int _pathColor;
	int ColorIndex;
	int iAltLow = 228;
	int iAltHigh = 252;
	
	ArrayList<Paint> Paints = new ArrayList<Paint>();
	ArrayList<Path> pathAL = new ArrayList<Path>();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_map_trial);
		

		Intent intent = getIntent();
		String fileName = intent.getStringExtra(PreviousRoutes.Selected_File);
		FileInputStream fis;
		try {
			// The next line is where you give the name of file you want to read
			fis = openFileInput(fileName);
			ObjectInputStream ois = new ObjectInputStream(fis);

			Object RouteGPS[] = (Object[]) ois.readObject();
			ois.close();
			length = RouteGPS.length;
			latA = new double[length];
			longA = new double[length];
			// Alength = Route.length; ---- belongs to pretty version
			Alength = RouteGPS.length;
			AltA = new double[Alength];
			for (int i = 2; i < Alength; i++) {
				Alt = ((locationData) RouteGPS[i]).pressure;
				AltA[i] = Alt;

			}
			for (int i = 2; i < length; i++) {
				lati = ((locationData) RouteGPS[i]).latitude;
				longi = ((locationData) RouteGPS[i]).longitude;
				latA[i] = lati;
				longA[i] = longi;
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (StreamCorruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//Creating an instance on mapview
		mapView = (MapView) findViewById(R.id.mapview);
		//Enable built in zoom controls
		mapView.setBuiltInZoomControls(true);

		gP = new GeoPoint((int) (latA[10] * 1E6), (int) (longA[10] * 1E6));
		;// Creating a GeoPoint

		mc = mapView.getController();
		mc.setCenter(gP);
		mc.setZoom(18);
		// Initializing the MapController and setting the map to 
		// center at thedefined GeoPoint
		mapOverlays = mapView.getOverlays();
		projection = mapView.getProjection();

		myoverlay = new MyOverlay(latA, longA, AltA);
		mapOverlays.add(myoverlay);

	}

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	class MyOverlay extends Overlay {
		double latA[];
		double longA[];
		double Alt;
		double AltA[];
		double AltA1[] = new double[2];
		GeoPoint gP[];
		int switchColor = 1;
		int in = 0;
		

		public MyOverlay(double lat[], double longi[], double alt[]) {
			super();
			latA = lat;
			longA = longi;
			AltA = alt;
			gP = new GeoPoint[latA.length];
			iAltLow = (int) min(alt);
			iAltHigh = (int) max(alt);
			
			
		}

		public void CreatePaints() {
			for (int i = 0; i < 130 * 2; i++) {
				Paint pain = new Paint();
				pain.setStyle(Paint.Style.STROKE);
				pain.setStrokeWidth(5);
				//pain.setAlpha(90);
				if (i < 129) {
					RColor = 255;
					GColor = 168 - (i + 1);
					BColor = 130 - (i + 1);
					Alpha  = 255 - (i + 1);
				} else {
					RColor = 0;
					GColor = 38;
					BColor = 125 + ((i / 2) + 1);
					Alpha =  125 + ((i / 2) + 1);
				}
				_pathColor = Color.argb(Alpha,RColor, GColor, BColor);
				pain.setColor(_pathColor);
				Paints.add(pain);
			}
		}
		
		public void AssignColor(int iAlt, int plusOne) {
			if (iAlt < plusOne) {
			ColorIndex = (iAlt-iAltLow-1)*130/(iAltHigh-iAltLow);
			}
			if (iAlt > plusOne) {
			ColorIndex = 2*(iAlt-iAltLow-1)*130/(iAltHigh-iAltLow);
			//TODO
			}
			if (ColorIndex>258){ColorIndex = 258;}
			if( ColorIndex<0 ) {ColorIndex = 0;}
			//TODO implement below code
			/*
			if (iAlt == plusOne) {
			RColor = 0;
			GColor = 225;
			BColor = 0;
			// Do Nothing
			}
			if (iAlt == 0 && plusOne == 0) {
			RColor = 0;
			GColor = 0;
			BColor = 200;
			}
			* RColor = (int) ((( iAlt - AltLow) / AltLow) * 255); GColor = 0;
			* BColor = 0;
			*/
			}
		
		//===================================================== max Alt
		public double max(double[] t) {
		    double maximum = t[0];   // start with the first value
		    for (int i=1; i<t.length; i++) {
		        if (t[i] > maximum) {
		            maximum = t[i];   // new maximum
		        }
		    }
		    return maximum;
		}
		
		//===================================================== min Alt
				public double min(double[] t) {
				    double minimum = t[0];   // start with the first value
				    for (int i=1; i<t.length; i++) {
				        if (t[i] < minimum) {
				            minimum = t[i];   // new maximum
				        }
				    }
				    return minimum;
				}//end method min

		public void draw(Canvas canvas, MapView mapv, boolean shadow) {
			super.draw(canvas, mapv, shadow);
			// Configuring the paint brush
			Paint mPaint = new Paint();
			mPaint.setDither(true);
			mPaint.setColor(Color.RED);
			mPaint.setStyle(Paint.Style.FILL_AND_STROKE);
			mPaint.setStrokeJoin(Paint.Join.ROUND);
			mPaint.setStrokeCap(Paint.Cap.ROUND);
			mPaint.setStrokeWidth(4);

			Paint mPaint2 = new Paint();
			mPaint2.setDither(true);
			mPaint2.setColor(Color.BLACK);
			mPaint2.setStyle(Paint.Style.FILL_AND_STROKE);
			mPaint2.setStrokeJoin(Paint.Join.ROUND);
			mPaint2.setStrokeCap(Paint.Cap.ROUND);
			mPaint2.setStrokeWidth(4);
			CreatePaints();

			for (int index = 2; index < latA.length; index++) {
				gP[index] = new GeoPoint((int) (latA[index] * 1E6),
						(int) (longA[index] * 1E6));
			}

			Point p1 = new Point();
			Point p2 = new Point();
			Path path1 = new Path();
			
			
			for (int i = 2; i < latA.length - 1; i++) {

				projection.toPixels(gP[i], p1);
				projection.toPixels(gP[i + 1], p2);
				path1 = new Path();
				path1.moveTo(p2.x, p2.y);// Moving to Islamabad location. 
				path1.lineTo(p1.x, p1.y);// Path to Rawalpindi
				// Add code here to setup paint
				/*
				if (i > latA.length / 2) {
					canvas.drawPath(path1, mPaint2);// Actually drawing the path
				} else {
					canvas.drawPath(path1, mPaint);
				}*/
				AssignColor( (int) AltA[i], (int) AltA[i+1]);
				System.out.println(ColorIndex);
				canvas.drawPath(path1, Paints.get(ColorIndex));// Actually drawing the path

			}

		}

	}
}
