package com.example.tracktrek;

import java.util.List;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.Point;
import android.graphics.RectF;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

public class RoutePathOverlay extends Overlay {

	// Colors
	private int hotred = 255;
	private int Lowhotgreen = 38;
	private int Highhotgreen = 168;
	private int Lowhotblue = 0;
	private int Highhotblue = 130;

	private int coolred = 0;
	private int coolgreen = 38;
	private int Lowcoolblue = 125;
	private int Highcoolblue = 225;
	private int NumberofColors = 130;
	// Determine Color Resolution & Apply it

	private double AltHigh = 0;
	private int iAltHigh ;
	private double AltLow = 50000;
	private int iAltLow;

	private int RColor;
	private int GColor;
	private int BColor;

	private int _pathColor;
	private final List<GeoPoint> _points;
	private boolean _drawStartEnd;
	private double _AltA[];
	private int _iAltA[];
	private int length;
	private int ColorRes;

	public RoutePathOverlay(List<GeoPoint> points, double AltA[]) {
		this(points, Color.RED, true, AltA);
	}

	public RoutePathOverlay(List<GeoPoint> points, int pathColor,
			boolean drawStartEnd, double AltA[]) {
		_points = points;
		_pathColor = pathColor;
		_drawStartEnd = drawStartEnd;
		_AltA = AltA;
	}

	private void drawOval(Canvas canvas, Paint paint, Point point) {
		Paint ovalPaint = new Paint(paint);
		ovalPaint.setStyle(Paint.Style.FILL_AND_STROKE);
		ovalPaint.setStrokeWidth(2);
		int _radius = 6;
		RectF oval = new RectF(point.x - _radius, point.y - _radius, point.x
				+ _radius, point.y + _radius);
		canvas.drawOval(oval, ovalPaint);
	}

	public boolean draw(Canvas canvas, MapView mapView, boolean shadow,
			long when) {
		Projection projection = mapView.getProjection();
		if (shadow == false && _points != null) {
			Point startPoint = null, endPoint = null;
			Path path = new Path();
			length = _AltA.length;
			_iAltA = new int[length];

			for (int ii = 0; ii < length; ii++) {
				_iAltA[ii] = (int) Math.round(_AltA[ii]); // Convert AltArray to
														// integers
				if (_AltA[ii] > AltHigh) {
					AltHigh = _AltA[ii];
				} else if (_AltA[ii] < AltLow) {
					AltLow = _AltA[ii];
				}
			}
			
			
			iAltHigh = (int) Math.round(AltHigh);
			iAltLow = (int) Math.round(AltLow);
			System.out.println(iAltLow);
			System.out.println(iAltHigh);
			
			if(iAltHigh != iAltLow){
			   ColorRes = (NumberofColors) / (iAltHigh - iAltLow);
			}
			else {ColorRes = 1;}
			
			for (int i = 0; i < length; i++) {
				_iAltA[i] = (int) Math.round(_AltA[i]);
				
			}
			// Creating the path now
			for (int i = 0; i < _points.size()-1; i++) {
				GeoPoint gPointA = _points.get(i);
				GeoPoint gPointB = _points.get(i+1);
				Point pointA = new Point();
				Point pointB = new Point();
				projection.toPixels(gPointA, pointA);
				projection.toPixels(gPointB, pointB);
				if (i == 0) { // This is the starting point
					startPoint = pointA;
					path.moveTo(pointA.x, pointA.y);
				} else {
					if (i == _points.size() - 1) // This is the end point
						endPoint = pointA;
					path.lineTo(pointA.x, pointA.y);
				}

				Paint paint = new Paint();
				paint.setAntiAlias(true);
				// TODO
				if (i < length-1) {
					AssignColor(_iAltA[i], _iAltA[i + 1], length);
				}
				_pathColor = Color.rgb(RColor, GColor, BColor);
				System.out.println(_pathColor);
				paint.setColor(_pathColor);
				paint.setStyle(Paint.Style.STROKE);
				paint.setStrokeWidth(5);
				paint.setAlpha(90);
				//System.out.println(paint.getColor());
				if (getDrawStartEnd()) {
					if (startPoint != null) {
						drawOval(canvas, paint, startPoint);
					}
					if (endPoint != null) {
						drawOval(canvas, paint, endPoint);
					}
				}
				if (!path.isEmpty()){
					//canvas.drawPath(path, paint);
					canvas.drawLine(pointA.x, pointA.y, pointB.x, pointB.y, paint);
					//System.out.println(_iAltA[i]);
				//System.out.println(path.toString());
				}
			}
			return super.draw(canvas, mapView, shadow, when);
		} else
			return false;
	}

	public boolean getDrawStartEnd() {
		return _drawStartEnd;
	}

	public void setDrawStartEnd(boolean markStartEnd) {
		_drawStartEnd = markStartEnd;
	}
/*
	public void AltitudeMinMax(int iAltArray[], int iAltMeasures) {
		for (int i = 0; i < iAltMeasures; i++) {
			iAltArray[i] = Math.round(AltArray[i]); // Convert AltArray to
													// integers
			if (AltArray[i] > AltHigh) {
				AltHigh = AltArray[i];
			} else if (AltArray[i] < AltLow) {
				AltLow = AltArray[i];
			}
		}
	}
*/
	// Determine If Hot or Cold Number. Then Assign an RGB color value.
	//ColorRes = (NumberofColors) / (iAltHigh - iAltLow);
	public void AssignColor(int iAlt, int plusOne, int AltMeasures) {
			 if (iAlt < plusOne) {
				RColor = hotred;
				GColor = (ColorRes * (iAlt - iAltLow)) + Lowhotgreen;
				BColor = (ColorRes * (iAlt - iAltLow)) + Lowhotblue;
				if (BColor > Highhotblue) {
					BColor = Highhotblue;
				}
				if (GColor > Highhotgreen) {
					GColor = Highhotgreen;
				}

			} 
			 if (iAlt > plusOne) {
				RColor = coolred;
				GColor = coolgreen;
				BColor = (ColorRes * (iAlt - iAltLow)) + Lowcoolblue;
				if (BColor > Highcoolblue) {
					BColor = Highcoolblue;
				}
			} 
			 if (iAlt == plusOne) {
				 RColor = 0;
				 GColor = 225;
				 BColor = 0;
				// Do Nothing
			}
			 if(iAlt == 0 && plusOne == 0){
				 RColor = 0;
				 GColor = 0;
				 BColor = 200;
			 }
			
		/*
		RColor = (int) ((( iAlt - AltLow) / AltLow) * 255);
		GColor = 0;
		BColor = 0;
		*/
	}

}
