package com.example.tracktrek;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.Toast;

/*
 * At this time settings does nothing!
 * 
 */

public class Settings extends Activity {

    protected int mPos;
    
    protected String mSelection;
    
    protected ArrayAdapter<CharSequence> mAdapter;

    public static final int DEFAULT_POSITION = 2;

    public static final String PREFERENCES_FILE = "SpinnerPrefs";

    public static final String PROPERTY_DELIMITER = "=";

    public static final String POSITION_KEY = "Position";

    public static final String SELECTION_KEY = "Selection";

    public static final String POSITION_MARKER = POSITION_KEY + PROPERTY_DELIMITER;

    public static final String SELECTION_MARKER = SELECTION_KEY + PROPERTY_DELIMITER;

    @Override
public void onCreate(Bundle savedInstanceState) {
     
super.onCreate(savedInstanceState);

setContentView(R.layout.activity_settings);

Spinner MilesKM = (Spinner) findViewById(R.id.spinnerMile_KM);

this.mAdapter = ArrayAdapter.createFromResource(this, R.array.Miles_KM,
				android.R.layout.simple_spinner_dropdown_item);

MilesKM.setAdapter(this.mAdapter);

OnItemSelectedListener spinnerListener = new myOnItemSelectedListener(
										 this, this.mAdapter);

MilesKM.setOnItemSelectedListener(spinnerListener);

}

public class myOnItemSelectedListener implements OnItemSelectedListener {


//  provide local instances of the mLocalAdapter and the mLocalContext

ArrayAdapter<CharSequence> mLocalAdapter;
Activity mLocalContext;

public myOnItemSelectedListener(Activity c, ArrayAdapter<CharSequence> ad) {

this.mLocalContext = c;
this.mLocalAdapter = ad;
}

public void onItemSelected(AdapterView<?> parent, View v, int pos,
long row) {

Settings.this.mPos = pos;
Settings.this.mSelection = parent.getItemAtPosition(pos).toString();
}

public void onNothingSelected(AdapterView<?> parent) {
// do nothing
}
}

public void onResume(Bundle SavedInstanceState) {
super.onResume();
if (!readInstanceState(this)) setInitialState();

Spinner restoreSpinner = (Spinner)findViewById(R.id.spinnerMile_KM);
        restoreSpinner.setSelection(getSpinnerPosition());
}


public void onPause(Bundle SavedInstaceState) {
super.onPause();
if (!writeInstanceState(this)) {
            Toast.makeText(this,"Failed to write state!", Toast.LENGTH_LONG).show();
         }
}
/*
public void onStop(Bundle SavedInstranceState){
super.onStop();
if (!writeInstanceState(this)) {
            Toast.makeText(this,"Failed to write state!", Toast.LENGTH_LONG).show();
         }
}
*/

public void setInitialState() {

        this.mPos = DEFAULT_POSITION;  
    }

public boolean readInstanceState(Context c) {

SharedPreferences p = c.getSharedPreferences(PREFERENCES_FILE, MODE_WORLD_READABLE);

this.mPos = p.getInt(POSITION_KEY, Settings.DEFAULT_POSITION);
        this.mSelection = p.getString(SELECTION_KEY, "");
        return (p.contains(POSITION_KEY));
}

public boolean writeInstanceState(Context c) {

SharedPreferences p = c.getSharedPreferences(Settings.PREFERENCES_FILE, MODE_WORLD_READABLE);
SharedPreferences.Editor e = p.edit();

e.putInt(POSITION_KEY, this.mPos);
e.putString(SELECTION_KEY, this.mSelection);

return (e.commit());
}

    public int getSpinnerPosition() {
        return this.mPos;
    }

    public void setSpinnerPosition(int pos) {
        this.mPos = pos;
    }

    public String getSpinnerSelection() {
        return this.mSelection;
    }

    public void setSpinnerSelection(String selection) {
        this.mSelection = selection;
    }

}

